package com.example.nearbylocations.data.local.datastore

import android.content.Context
import android.location.Location
import androidx.datastore.core.DataStore
import androidx.datastore.preferences.core.*
import androidx.datastore.preferences.preferencesDataStore
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.map
import javax.inject.Inject

/**
 * This class is an alternative api for SharedPreferences, that is kotlin friendly and support flows and suspend functions.
 *
 * @param context Application context that generated by Hilt to construct [DataStore] instance.
 */
class DataStorePreferences @Inject constructor(private val context: Context) {

    // Create some keys
    companion object {
        private val USER_LOCATION = stringPreferencesKey("user_location")
    }

    private val Context.dataStore: DataStore<Preferences> by preferencesDataStore(name = "user_preference")

    /**
     * Store user location
     *
     * @param userLocation location of the user
     */
    suspend fun storeUserLocation(userLocation: String) {
        context.dataStore.edit { preferences ->
            preferences[USER_LOCATION] = userLocation
        }
    }

    /**
     * Get user location
     */
    val userLocation: Flow<String> = context.dataStore.data
        .map { preferences ->
            val userLocation = preferences[USER_LOCATION] ?: ""
            userLocation
        }

    /**
     * Clear data store
     */
    suspend fun clearDataStore() {
        context.dataStore.edit { it.clear() }
    }
}
